// truVid.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <qedit.h>
#include <DShow.h>
#include <atlbase.h>
#include <Windows.h>

using namespace std;


#define delAchPlayCode \
	if (achPlayCode != NULL) \
		delete[] achPlayCode;

#define delAchNyan \
	delAchPlayCode; \
	delete[] achNyan;

#define delAchSong \
	delAchNyan; \
	delete[] achSong;

#define delAchVid \
	delAchSong; \
	delete[] achVid;


#define safeReleases \
	SafeRelease(&pGraph); \
	SafeRelease(&pControl); \
	SafeRelease(&pEvent); \
	SafeRelease(&pGrabberBaseFilter); \
	SafeRelease(&pSampleGrabber); 

bool bOFlag;
bool bNFlag;
bool bAFlag;
bool bBFlag;
bool bPFlag;
bool bYFlag;
bool bDFlag;

template <class T> void SafeRelease(T **ppT)
{
    if (*ppT)
    {
        (*ppT)->Release();
        *ppT = NULL;
    }
}

int Power(int nBase, int nPower);

int FindString(int nStart, const char achString[4], unsigned char* achBuf)
{
	int nMatches = 0;
	while (nMatches < 4)
	{
		if (achBuf[nStart] == achString[nMatches])
			nMatches++;
		else
			nMatches = 0;
		nStart++;
	}
	return nStart;
}

int GetValue(int &nStart, int nBytes, unsigned char* achBuf)
{
	int nTotal = 0;
	for (int iii = 0; iii < nBytes; iii++)
	{
		nTotal+= achBuf[nStart] * Power(2, 8*iii);
		nStart++;
	}
	return nTotal;
}


int Power(int nBase, int nPower)
{
	int nResult = 1;
	for (int iii = 0; iii < nPower; iii++)
		nResult*= nBase;
	return nResult;
}

void FindCutoff(int &nCutoff, int nToStop, int* anColors)
{
	int nInByte = 0;
	for (int iii = 0; iii < nToStop; iii++)
	{
		if (nInByte != anColors[nCutoff])
			nInByte++;
		else
		{
			nInByte = 0;
			nCutoff++;
		}
	}
}

double* PixelLoc(int nX, int nY, double adPicture[96*64], double &dGarbage)
{
	if (nX < 0 || nX >= 96 || nY < 0 || nY >=64)
		return &dGarbage;
	return &adPicture[nY*96 + nX];
}

void ClipPixel(double * dPos)
{
	if (*dPos > 255)
		*dPos = 255;
	if (*dPos < 0)
		*dPos = 0;
	return;
}

void WriteForApp(int nAmount, int &nCurLocation, char* achBuffer, int &nPages, fstream *newFile)
{
	for (int iii = 0; iii < nAmount; iii++)
	{
		newFile->put(achBuffer[iii]);
		nCurLocation++;
		if (nCurLocation == 0x4000)
		{
			newFile->put(00);
			nCurLocation = 1;
			nPages++;
		}
	}
}

int MakeFileName(char achFinal[MAX_PATH], char * achInit)
{
	int nPathLength = 0;
	for (int iii = 0; achInit[iii]; iii++)
	{
		achFinal[nPathLength] = achInit[iii];
		if (achFinal[nPathLength] == 0x5C)
		{
			nPathLength++;
			achFinal[nPathLength] = 0x5C;
		}
		nPathLength++;
	}
	return nPathLength;
}

class CSampleGrabberCB: public ISampleGrabberCB
{
public:
	ISampleGrabber *pSampleGrabber;
	unsigned char *achOutBuf;
	int nFrames;
	int nFrameCount;
	double adDitherFilter[96*64];
	bool bOrderedD;
	bool bFSDither;
	bool bAbsolute;

	CSampleGrabberCB(void)
	{
		achOutBuf = NULL;
		nFrames = 0;
		nFrameCount = 2;
		pSampleGrabber = NULL;
		bOrderedD = false;
		bFSDither = true;
		bAbsolute = false;

		int anDitherA[10] = {7, 5, -7, -3, -1, 10, 4, -8, -4, 2};
		int anDitherB[10] = {-9, -5, 1, 8, 6, -6, -2, 0, 9, 3};
		int anDitherStarts[5] = {0, 4, 8, 2, 6};
		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = 0; nColumn < 96; nColumn++)
				adDitherFilter[nRow*96 + nColumn] = anDitherA[(anDitherStarts[(nRow/2)%5] + nColumn) % 10];
			nRow++;
			for (int nColumn = 0; nColumn < 96; nColumn++)
				adDitherFilter[nRow*96 + nColumn] = anDitherB[(anDitherStarts[(nRow/2)%5] + nColumn) % 10];

		}

	}

	STDMETHOD(QueryInterface)(REFIID InterfaceIdentifier, VOID** ppvObject)
	{
		if (InterfaceIdentifier == __uuidof(ISampleGrabberCB))
		{
			*ppvObject = (ISampleGrabberCB**) this;
			return S_OK;
		}
		return E_NOINTERFACE;
	}
	STDMETHOD_(ULONG, AddRef)()
	{
		return 2;
	}
	STDMETHOD_(ULONG, Release)()
	{
		return 1;
	}
	STDMETHODIMP SampleCB(double dTime, IMediaSample *pms)
	{
		return 0;
	}

	STDMETHODIMP BufferCB(double dSampleTime, byte *pBuffer, long nBufSize)
	{
		nFrameCount++;
		if (nFrameCount != 3)
			return 0;
		nFrameCount = 0;
		AM_MEDIA_TYPE MediaType;
		ZeroMemory(&MediaType, sizeof(MediaType));
		HRESULT hr = pSampleGrabber->GetConnectedMediaType(&MediaType);
		if (FAILED(hr))
		{
			cout << "Can't get media type" << endl;
			return hr;
		}
		VIDEOINFOHEADER *pVideoHeader = (VIDEOINFOHEADER*)MediaType.pbFormat;
		if (pVideoHeader == NULL)
		{
			cout << "pVideoHeader = NULL" << endl;
			return hr;
		}
		
		BITMAPINFO BitmapInfo;
		ZeroMemory(&BitmapInfo, sizeof(BitmapInfo));
		CopyMemory(&BitmapInfo.bmiHeader, &(pVideoHeader->bmiHeader), sizeof(BITMAPINFOHEADER));

		if (BitmapInfo.bmiHeader.biHeight != 128)
		{
			cout << "Error, height not 128" << endl;
			exit(1);
		}
		if (BitmapInfo.bmiHeader.biWidth != 192)
		{
			cout << "Error, width not 192" << endl;
			exit(1);
		}


		double adFrameBrightness[96*64] = {0};
		int anBrightnessCount[256] = {0};

		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = 0; nColumn < 96; nColumn++)
			{
				int nOrigin = (63-nRow)*192*3*2 + nColumn*3*2;
				double dThisBrightness = (double)(
					(unsigned char)pBuffer[nOrigin] * 2126 +
					(unsigned char)pBuffer[nOrigin + 1] * 7152 + 
					(unsigned char)pBuffer[nOrigin + 2] * 0722 +
					(unsigned char)pBuffer[nOrigin + 3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 4] * 7152 +
					(unsigned char)pBuffer[nOrigin + 5] * 0722 +
					(unsigned char)pBuffer[nOrigin + 192*3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 1] * 7152 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 2] * 0722 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 4] * 7152 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 5] * 0722) / 40000;

				adFrameBrightness[nRow*96 + nColumn] = dThisBrightness;
				anBrightnessCount[(int)floor(dThisBrightness)]++;
			}
		}

		int nPixelsCounted = 96*64;
		for (int iii = 0; iii < 256; iii++)
		{
			if (anBrightnessCount[iii] > 96*64/10)			//this implies a boarder
			{
				nPixelsCounted-= anBrightnessCount[iii];
				anBrightnessCount[iii] = 0;
			}
		}

		int nLowCutoff = 0x00;
		int nMidCutoff = 0x00;
		int nHighCutoff = 0x00;
		FindCutoff(nLowCutoff, nPixelsCounted/4, anBrightnessCount);
		FindCutoff(nMidCutoff, nPixelsCounted/2, anBrightnessCount);
		FindCutoff(nHighCutoff, nPixelsCounted*3/4, anBrightnessCount);

		if (bAbsolute)
		{
			nLowCutoff = 0x40;
			nMidCutoff = 0x80;
			nHighCutoff = 0xC0;
		}


		unsigned char achColors[4] = {nLowCutoff / 2, (nMidCutoff + nLowCutoff) / 2, (nMidCutoff + nHighCutoff) / 2, (nHighCutoff+255) / 2};

		double dFilterStrength = (nHighCutoff - nLowCutoff)/4/10   /2 ; //half of the average of the spaces /10 because filter is 10 based

		double dGarbage = 0;
		bool bReverse = false;

		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = (bReverse ? 95 : 0); (bReverse ? nColumn >= 0 : nColumn < 96); (bReverse ? nColumn-- : nColumn++))
			{
				int nPutLoc = nRow*96 + nColumn;
				double dThisActual = *PixelLoc(nColumn, nRow, adFrameBrightness, dGarbage) + bOrderedD*(adDitherFilter[nPutLoc]*dFilterStrength);

				int nThisNew = 3;
				if (dThisActual > nMidCutoff)
					nThisNew-= 2;
				if ((dThisActual > nHighCutoff) || ((dThisActual > nLowCutoff) && (dThisActual <= nMidCutoff)))
					nThisNew--;

				if (bReverse)
				{
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2]/2 + nThisNew/2*128;
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1]/2 + (nThisNew & 1)*128;
				}
				else
				{
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2]*2 + nThisNew/2;
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1]*2 + (nThisNew & 1);
				}

				if (bFSDither)
				{
					double *dPos;
					double dQuantError = (dThisActual - achColors[3-nThisNew])/16;

					dPos = PixelLoc(nColumn + (bReverse ? -1 : 1) , nRow, adFrameBrightness, dGarbage);
					*dPos += dQuantError*7;
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn - 1, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError * (bReverse ? 1 : 3);
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError*5;
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn + 1, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError * (bReverse ? 3 : 1);
					ClipPixel(dPos);
				}
				nPutLoc++;
			}
			bReverse^= 1;
		}




		nFrames++;
		if (dSampleTime == floor(dSampleTime))
			cout << dSampleTime << " ";
		return 0;
	}
};

int ConvertSong(char achSongPath[MAX_PATH], unsigned char * &achSong)
{
	ifstream fSongFile (achSongPath, ios::_Nocreate | ios::binary | ios::ate | ios::out);

	if (!fSongFile)
	{
		cerr << achSongPath << " Not found" << endl;
		return 0;
	}
	
	int nFileSize;
	nFileSize = (int)fSongFile.tellg();
	int nCurrentByte = 0;
	achSong = new unsigned char [nFileSize];
	fSongFile.seekg(0, ios::beg);
	fSongFile.read((char*)achSong, nFileSize);
	fSongFile.close();

	nCurrentByte = FindString(0, "fmt ", achSong) + 4;
	if (GetValue(nCurrentByte, 2, achSong) != 1)
	{
		cout << "Error: Compressed" << endl;
		delete[] achSong;
		return 0;
	}

	int nChannels = GetValue(nCurrentByte, 2, achSong);
	if (nChannels > 2)
	{
		cout << "Error: Too many channels" << endl;
		delete[] achSong; 
		return 0;
	}

	int nSampleRate = GetValue(nCurrentByte, 4, achSong);
	if (nSampleRate != 18000)
	{
		cout << "Warning: Sample rate is " << nSampleRate;
		cout << " it should be 18000" << endl;
	}

	nCurrentByte+= 6;
	int nBitsPerSample = GetValue(nCurrentByte, 2, achSong);

	if (nBitsPerSample != 8 && nBitsPerSample != 16)
	{
		cout << "Error: Invalid bits per sample" << endl;
		delete[] achSong;
		return 0;
	}

	int nExtraBytes = FindString(0, "data", achSong) + 4;

	for (int iii = 0; iii < nFileSize - nExtraBytes; iii++)
		achSong[iii] = achSong[iii + nExtraBytes];

	nFileSize-= nExtraBytes;

	if (nBitsPerSample == 16)
	{
		cout << "Converting to 8 bit..." << endl;
		for (int iii = 0; iii < nFileSize / 2; iii++)
			achSong[iii] = (achSong[iii*2 + 1] + 0x80) & 0xFF;
		nFileSize/=2;
	}

	if (nChannels == 2)
	{
		cout << "Converting to one channel..." << endl;
		for (int iii = 0; iii < nFileSize / 2; iii++)
			achSong[iii] = (achSong[iii*2] + achSong[iii*2 + 1]) / 2;
		nFileSize/=2;
	}

	for (int iii = 0; iii < nFileSize; iii++)
		achSong[iii] = achSong[iii] * 0xBE / 0xFF + 1;

	nFileSize+=2;
	achSong[nFileSize-1] = 0xFF;
	achSong[nFileSize-2] = 0;
	return nFileSize;

}

int ConvertVid(char achVidPath[MAX_PATH], unsigned char * achVideoBuf, int &nFrames)
{
	IGraphBuilder *pGraph = NULL;
	IMediaControl *pControl = NULL;
	IMediaEvent *pEvent = NULL;
	IBaseFilter *pGrabberBaseFilter = NULL;
	ISampleGrabber *pSampleGrabber = NULL;


	HRESULT hr = CoInitialize(NULL);
	if (FAILED(hr))
	{
		printf("ERROR - Could not initialize COM library");
		safeReleases; 
		return 0;
	}

	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						IID_IGraphBuilder, (void **)&pGraph);
	if (FAILED(hr))
	{
		printf("ERROR - Could not create the Filter Graph Manager.");
		safeReleases; 
		return 0;
	}

	AM_MEDIA_TYPE mt;
	hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&pGrabberBaseFilter);
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	pGrabberBaseFilter->QueryInterface(IID_ISampleGrabber, (void**)&pSampleGrabber);
	if (pSampleGrabber == NULL)
	{
		safeReleases; 
		return 0;
	}

	hr = pGraph->AddFilter(pGrabberBaseFilter,L"Grabber");
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
	mt.majortype = MEDIATYPE_Video;
	mt.subtype = MEDIASUBTYPE_RGB24;
	mt.formattype = FORMAT_VideoInfo;
	hr = pSampleGrabber->SetMediaType(&mt);
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	hr = pGraph->QueryInterface(IID_IMediaControl, (void **)&pControl);
	hr = pGraph->QueryInterface(IID_IMediaEvent, (void **)&pEvent);

	LPWSTR lFileName = SysAllocStringLen(NULL, MAX_PATH);
	MultiByteToWideChar(CP_ACP, 0, achVidPath, -1, lFileName, MAX_PATH);
	hr = pGraph->RenderFile(lFileName, NULL);
	SysFreeString(lFileName);
	if (FAILED(hr))
	{
		cout << "Video file probably not found" << endl;
		safeReleases;
		return 0;
	}

	CSampleGrabberCB CB;
	CB.pSampleGrabber = pSampleGrabber;
	hr = pSampleGrabber->SetCallback(&CB, 1);
	CB.achOutBuf = achVideoBuf;

	if (bAFlag)
		CB.bAbsolute = true;
	if (bBFlag)
		CB.bOrderedD = true;
	if (bNFlag)
		CB.bFSDither = false;
	if (bOFlag)
	{
		CB.bFSDither = false;
		CB.bOrderedD = true;
	}

	CComQIPtr<IMediaSeeking> pSeek = pControl;
	LONGLONG nDuration;
	hr = pSeek->GetDuration(&nDuration);
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	REFERENCE_TIME rtStart = 0;
	REFERENCE_TIME rtStop = nDuration-1;

	hr = pSeek->SetPositions(&rtStart, AM_SEEKING_AbsolutePositioning,
		&rtStop, AM_SEEKING_AbsolutePositioning);

	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	hr = pSeek->SetRate(1.00);		//I would love to set this to something faster
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	CComQIPtr<IVideoWindow> pVideoWindow = pGraph;
	hr = pVideoWindow->put_AutoShow(OAFALSE);

	CComQIPtr<IBasicAudio> pBasicAudio = pGraph;
	hr = pBasicAudio->put_Volume(-10000);		// -10,000 is silence

	hr = pControl->Run();
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	    long evCode;
    hr = pEvent->WaitForCompletion(INFINITE, &evCode);
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}
	cout << endl;
	nFrames = CB.nFrames;
	return CB.nFrames*768*2;
}






int main(int argc, char **argv)
{	
	cout << endl;
	cout << "===================== TruVid =============================" << endl;
	cout << "By: Brian Coventry" << endl;

	bOFlag = false;
	bNFlag = false;
	bAFlag = false;
	bBFlag = false;
	bPFlag = false;
	bYFlag = false;
	bDFlag = false;
	int nActualArgs = argc;

	for (int iii = 1; iii < argc; iii++)
	{
		if (argv[iii][0] == '-')
		{
			switch (argv[iii][1])
			{
			case 'O':
				bOFlag = true;
				break;
			case 'o':
				bOFlag = true;
				break;
			case 'N':
				bNFlag = true;
				break;
			case 'n':
				bNFlag = true;
				break;
			case 'A':
				bAFlag = true;
				break;
			case 'a':
				bAFlag = true;
				break;
			case 'B':
				bBFlag = true;
				break;
			case 'b':
				bBFlag = true;
				break;
			case 'P':
				bPFlag = true;
				break;
			case 'p':
				bPFlag = true;
				break;
			case 'Y':
				bYFlag = true;
				break;
			case 'y':
				bYFlag = true;
				break;
			case 'D':
				bDFlag = true;
				break;
			case 'd':
				bDFlag = true;
				break;
			}
			nActualArgs--;
		}
	}

	int nArgStart = argc-nActualArgs;


	if (nActualArgs != (bYFlag ? 5 : 4))
	{
		cout << "Proper command syntax is: truSound [flags] song.wav video.wmv output.bin" << endl;
		cout << "Flags:" << endl;
		cout << " -A - use absolute brightness cutoffs (relative is default)" << endl;
		cout << " -B - use both dithering styles (not really a good idea)" << endl;
		cout << " -D - Audio and video loop with each other (independent is default)" << endl;
		cout << " -N - don't use any dithering (Floyd - Steinburg dither is default)" << endl;
		cout << " -O - use ordered dithering (Floyd - Steinburg dither is default)" << endl;
		cout << " -P - compile for use with program (don't use)" << endl;
		cout << " -Y - compile for NyanCat (see readme)" << endl;
		exit(1);
	}
	
	char achNyanPath[MAX_PATH] = {0};
	if (bYFlag)
		MakeFileName(achNyanPath, argv[nArgStart + 1]);

	char achSongPath[MAX_PATH] = {0};
	MakeFileName(achSongPath, argv[nArgStart + 1 + bYFlag]);

	char achVidPath[MAX_PATH] = {0};
	MakeFileName(achVidPath, argv[nArgStart + 2 + bYFlag]);

	char achFinalPath[MAX_PATH] = {0};
	MakeFileName(achFinalPath, argv[nArgStart + 3 + bYFlag]);


	unsigned char * achPlayCode = NULL;
	int nPlayCodeSize = 0;
	if (!bPFlag)
	{
		char achName[13] = "playCode.bin";
		ifstream fPlayCode (achName, ios::_Nocreate | ios::binary | ios:: ate | ios:: out);
		if (!fPlayCode)
		{
			cerr << "playCode.bin not found" << endl;
			delAchPlayCode;
			exit(1);
		}
		nPlayCodeSize = (int)fPlayCode.tellg();
		achPlayCode = new unsigned char [nPlayCodeSize];
		fPlayCode.seekg(0, ios::beg);
		fPlayCode.read((char*)achPlayCode, nPlayCodeSize);
		fPlayCode.close();
	}

	unsigned char * achNyan = NULL;
	int nNyanSize = 0;
	if (bYFlag)
	{
		nNyanSize = ConvertSong(achNyanPath, achNyan);
		if (!nNyanSize)
		{
			delAchPlayCode;
			exit(1);
		}
	}

	unsigned char * achSong = NULL;
	int nSongSize = ConvertSong(achSongPath, achSong);
	if (!nSongSize)
	{
		delAchNyan;
		exit(1);
	}

	unsigned char * achVid = new unsigned char [3000000];
	int nFrames = 0;
	int nVidSize = ConvertVid(achVidPath, achVid, nFrames);
	if (!nSongSize)
	{
		cout << "Error in video conversion" << endl;
		delAchVid;
		exit(1);
	}




	fstream newFile(achFinalPath, ios::trunc | ios::in | ios::out | ios::binary);
	if (!newFile)
	{
		cout << "Open error on new file!" << endl;
		delAchVid;
		exit(1);
	}

	int nOnCalc = 0x80;
	int nPages = 0;
	newFile.seekp(0);
	if (!bPFlag)
		WriteForApp(nPlayCodeSize, nOnCalc, (char*)achPlayCode, nPages, &newFile);

	newFile.seekp(nPlayCodeSize + 6 + 3*bYFlag);
	nOnCalc+=6 + 3*bYFlag;							//this should never wrap to the next page

	if (bYFlag)
		WriteForApp(nNyanSize, nOnCalc, (char*)achNyan, nPages, &newFile);

	int nNyanOffset = nOnCalc + 0x4000;
	int nNyanPage = nPages;

	WriteForApp(nSongSize, nOnCalc, (char*)achSong, nPages, &newFile);


	int nVideoOffset = nOnCalc + 0x4000;
	int nVideoPage = nPages;

	WriteForApp(nVidSize, nOnCalc, (char *)achVid, nPages, &newFile);

	newFile.seekp(nPlayCodeSize);
	newFile.put((int)bDFlag | (bYFlag * 2));
	newFile.put(nVideoOffset & 255);
	newFile.put(nVideoOffset / 256);
	newFile.put(nVideoPage);
	newFile.put(nFrames & 255);
	newFile.put(nFrames / 256);
	if (bYFlag)
	{
		newFile.put(nNyanOffset & 255);
		newFile.put(nNyanOffset / 256);
		newFile.put(nNyanPage);
	}

	newFile.close();

	cout << "Pages: " << nPages+1 << endl;

	delAchVid;

	return(0);
}


		/*
		HDC hdcOldBmp = CreateCompatibleDC(NULL);
		HBITMAP hOldBmp; 
		hOldBmp = CreateDIBSection(hdcOldBmp, &BitmapInfo, DIB_RGB_COLORS,  

		if (hOldBmp == NULL)
			exit(1);

		int nResult = SetDIBits(hdcOldBmp, hOldBmp, 0, BitmapInfo.bmiHeader.biHeight,
			pBuffer, &BitmapInfo, DIB_RGB_COLORS);


		BITMAPINFO NewBitmapInfo;
		CopyMemory(&NewBitmapInfo, &BitmapInfo, sizeof(BitmapInfo));

		NewBitmapInfo.bmiHeader.biWidth = 96;
		NewBitmapInfo.bmiHeader.biHeight = 64;

		HDC hdcNewBmp = CreateCompatibleDC(NULL);
		HBITMAP hNewBmp;
		hNewBmp = CreateCompatibleBitmap(hdcNewBmp, 96, 64);

//		nResult = StretchBlt(hdcNewBmp, 0, 0, 96, 64, hdcOldBmp, 0, 0,
//			BitmapInfo.bmiHeader.biWidth,
//			BitmapInfo.bmiHeader.biHeight, COLORONCOLOR);

		nResult = SetPixel(hdcNewBmp, 0, 0, RGB(255, 255, 0));

		unsigned char* achPicData= new unsigned char [96*64*3];
		nResult = GetDIBits(hdcNewBmp, hNewBmp, 0, 64, achPicData, &NewBitmapInfo, DIB_RGB_COLORS); 

		NewBitmapInfo.bmiHeader.biSizeImage = 0;

		char achTempName[20] = "Temp.bmp";
	

		WriteBMP(achTempName, &(NewBitmapInfo.bmiHeader), NewBitmapInfo.bmiHeader.biSize,
			achPicData, 96*64*3);

		exit(0); */